import tornado.web
from models import User, Session

class Reincarnate(tornado.web.RequestHandler):
    async def post(self):
        user_id = self.get_secure_cookie("user")
        current_role = self.get_secure_cookie("role")
        if not user_id or not current_role:
            self.redirect("/login")
            return
        user = Session().query(User).filter(User.id == int(user_id)).first()
        if not user.caste == "Brahmins":
            self.render("error.html", type="error", message="Only brahmins can reincarnate")
            return

        if not current_role.decode('utf-8') == "rishi":
            self.render("error.html", type="error", message="Only rishi can reincarnate")
            return
        self.render("error.html", type="success", message="Here is your flag: blzh{XXXXXXXXXXXXXXXXXXXXX}")
        return
    

class AccountHandler(tornado.web.RequestHandler):
    async def get(self):
        user_id = self.get_secure_cookie("user")
        current_role = self.get_secure_cookie("role")
        if not user_id or not current_role:
            self.redirect("/login")
            return
        
        user = Session().query(User).filter(User.id == int(user_id)).first()

        self.render("account.html", username=user.username, otp=user.totp_enabled, firstname=user.firstname, lastname=user.lastname, day=user.day, month=user.month, year=user.year, karma=user.karma, caste=user.caste, role=current_role)
