import tornado.ioloop
import tornado.web
from handlers.auth import LoginHandler, RegisterHandler, Logout, Role
from handlers.twoFa import TwoFAHandler, TwoFASecretHandler, TwoFAEnablerHandler
from handlers.account import AccountHandler, Reincarnate
from models import User, Session
from tornado.httpserver import HTTPServer

def make_app():
    return tornado.web.Application([
        (r"/", MainHandler),
        (r"/login", LoginHandler),
        (r"/register", RegisterHandler),
        (r"/2fa", TwoFAHandler),
        (r"/2fa_setup", TwoFASecretHandler),
        (r"/account", AccountHandler),
        (r"/2fa_enable", TwoFAEnablerHandler),
        (r"/logout", Logout),
        (r"/role", Role),
        (r"/reincarnate", Reincarnate),
    ],
    template_path="templates",
    static_path="static",
    debug=False,
    cookie_secret='FrUjLrP2M00/wxjrQOpXXj2f4YOXEB91NqnqIOLfrz4qtkF00qlX1273BbVkvvB+0ik=',
    )


class MainHandler(tornado.web.RequestHandler):
    def get(self):
        user_id = self.get_secure_cookie("user")
        user = None
        if user_id:
            user = Session().query(User).filter(User.id == int(user_id)).first()
        self.render("index.html", username=user.username if user else None)


if __name__ == "__main__":
    app = make_app()
    server = HTTPServer(app)
    server.bind(8000, reuse_port=True)
    server.start(0)
    tornado.ioloop.IOLoop.current().start()