from sqlalchemy import create_engine, Column, Integer, String, Boolean
from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy.orm import sessionmaker


Base = declarative_base()
engine = create_engine('postgresql://indish_user:indish_password@indish_db/indish_db', pool_size=20, max_overflow=180, pool_timeout=5)
Session = sessionmaker(bind=engine)

class User(Base):
    __tablename__ = 'users'
    id = Column(Integer, primary_key=True)
    username = Column(String)
    password = Column(String(60))
    caste = Column(String, default="Shudras")
    totp_enabled = Column(Boolean, default=False)
    totp_secret = Column(String)
    karma = Column(Integer, default=0)
    firstname = Column(String)
    lastname = Column(String)
    day = Column(Integer)
    month = Column(Integer)
    year = Column(Integer)

Base.metadata.create_all(engine)